;	Run time start off for Small C.
;       194 bytes

_start:
        ld (_crt0_sp),SP

        call main             ;call main program
_cleanup:
;      ld a,(USG_BITS)
;      set 0,a
;      ld (USG_BITS),a
;                              ;Set ZS_BITS to recompute checksums
;      call OTH_EXIT           ;Calling this eliminates the special handling for exit()

        ld SP,(_crt0_sp)

        ret

_crt0_sp:   .dw  00


; .db 83,109,97,108,108,67,0
;
;*****************************************************
;						     *
;	runtime	library	for small C compiler	     *
;						     *
;	c.s - runtime routine for basic C code	     *
;						     *
;		Ron Cain			     *
;                                                    *
;       ZShell modifications by Jeremy Dewey         *
;						     *
;*****************************************************
;
; fetch char from (HL) and sign extend into HL
_gchar:  ld a,(hl)
_sxt:   ld l,a
	rlca
	sbc	a,a
	ld	h,a
	ret

; Replaced by 'call LD_HL_MHL'
; fetch int from (HL)
;_gint:   ld a,(hl)
;        inc     hl
;   ld h,(hl)
;   ld l,a
;   ret


;==========================================================================;
; store char from HL into (DE)
;==========================================================================;
_pchar: 	ld  		a,l
		ld		(de),a
		ret
;==========================================================================;


;==========================================================================;
; store int from HL into (DE)
;==========================================================================;
_pint:   	ld 		a,l
		ld		(de),a
		inc		de
		ld		a,h
		ld		(de),a
		ret
;==========================================================================;


; "or" HL and DE into HL
_or:  ld a,l
	or	e
	ld	l,a
	ld	a,h
	or	d
	ld	h,a
	ret
; "xor" HL and DE into HL
_xor: ld a,l
	xor	e
	ld	l,a
	ld	a,h
	xor	d
	ld	h,a
	ret
; "and" HL and DE into HL
_and: ld a,l
	and	e
	ld	l,a
	ld	a,h
	and	d
	ld	h,a
	ret
;
;......logical operations: HL set to 0 (false) or 1 (true)
;
; DE == HL
_eq:
R_crt0: call _cmp
	ret	z
	dec	hl
	ret
; DE != HL
_ne:
R_crt1: call _cmp
	ret	nz
	dec	hl
	ret

;==========================================================================;
; DE > HL [signed]
;==========================================================================;
_gt:            ex              de,hl
R_crt2:         call            _cmp
                ret             c
                dec             hl
                ret
;==========================================================================;

; DE <= HL [signed]
_le:
R_crt3: call _cmp
	ret	z
	ret	c
	dec	hl
	ret
; DE >= HL [signed]
_ge:
R_crt4: call _cmp
	ret	nc
	dec	hl
	ret
; DE < HL [signed]
_lt:
R_crt5: call _cmp
	ret	c
	dec	hl
	ret
; DE >= HL [unsigned]
_uge:
R_crt6: call _ucmp
	ret	nc
	dec	hl
	ret
; DE < HL [unsigned]
_ult:
R_crt7: call _ucmp
	ret	c
	dec	hl
	ret
; DE > HL [unsigned]
_ugt: ex de,hl
R_crt8: call _ucmp
	ret	c
	dec	hl
	ret
; DE <= HL [unsigned]
_ule:
R_crt9: call _ucmp
	ret	z
	ret	c
	dec	hl
	ret


;==========================================================================;
; signed compare of DE and HL
;   carry is sign of difference [set => DE < HL]
;   zero is zero/non-zero
;==========================================================================;
_cmp:           ld              a,e
                sub             l
                ld              e,a
                ld              a,d
                sbc             a,h
                ld              hl,1            ;preset true
       ;        jp              m,_cmp1         ;ZShell mod
                jr              c,_cmp1
                or              e               ;resets carry
                ret

_cmp1:          or e
                scf
                ret
;==========================================================================;

; unsigned compare of DE and HL
;   carry is sign of difference [set => DE < HL]
;   zero is zero/non-zero
_ucmp:   ld a,d
	cp	h
        jr nz,_ucmp1
	ld	a,e
	cp	l
_ucmp1:  ld hl,1    ;preset true
	ret
; shift DE right arithmetically by HL, move to HL
_asr: ex de,hl
_asr1:   dec   e
	ret	m
	ld	a,h
	rla
	ld	a,h
	rra
	ld	h,a
	ld	a,l
	rra
	ld	l,a
        jr _asr1
; shift DE left arithmetically by HL, move to HL
_asl: ex de,hl
_asl1:   dec   e
	ret	m
	add	hl,hl
        jr _asl1

;===========================================================================;
; HL = DE - HL
;===========================================================================;
_sub:           ld              a,e
                sub             l
                ld              l,a
                ld              a,d
                sbc             a,h
                ld              h,a
                ret
;===========================================================================;


; HL = -HL
_neg:
R_crt10: call _com
	inc	hl
	ret
; HL = ~HL
_com: ld a,h
	cpl
	ld	h,a
	ld	a,l
	cpl
	ld	l,a
	ret
; HL = !HL
_lneg:   ld a,h
	or	l
        jr z,_lneg1
        ld hl,0
	ret
_lneg1:  inc   hl
	ret
; HL = !!HL
_bool:
   ld a,h
   or l
   ret z
   ld hl,1
   ret

