/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   crt.h                          03/nov/98             lord_nexus@usa.net
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   crt
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#ifndef CRT_H
#define CRT_H

/* --- contants ---------------------------------------------------------- */

/* --- variables --------------------------------------------------------- */

extern char* _text_x (0x800d);   /* current text cursor positions */
extern char* _text_y (0x800c);

extern char* _menu_x (0x8215);   /* current menu/small text cursor positions */
extern char* _menu_y (0x8216);

extern char* _scr_top (0x8c8f);  /* top/bottom of screen, used by scroll (normally 0 and 8) */
extern char* _scr_btm (0x8c90);

/* --- defines ----------------------------------------------------------- */

/* Set text mode */
#define normtext asm("\tres 3,(IY+05)\n")
#define invtext  asm("\tset 3,(IY+05)\n")

/* Scroll the screen */
#define scroll   asm("\tROM_CALL(SCROLL_UP)\n")

/* Call this before you call scroll the first time */
#define scroll_i asm("\tres 1,(IY+0D)\n")

/* Clear the display */
#define clrscr asm("\tROM_CALL(CLEARLCD)\n")

/* --- functions --------------------------------------------------------- */


/* =======================================================================
   putn(int n)
   print integer
   ======================================================================= */
putn(n) int n; {
#asm
   ld hl,2
   add hl,sp
   call LD_HL_MHL
   ROM_CALL(D_HL_DECI)
#endasm
}


/* =======================================================================
   putc(char c)
   print char
   ======================================================================= */
putc(c) char c; {
#asm
   ld hl,2
   add hl,sp
   ld a,(hl)
   ROM_CALL(TX_CHARPUT)
#endasm
}


/* =======================================================================
   puts(char* c)
   print string
   ======================================================================= */
puts(str) char* str; {
#asm
   ld hl,2
   add hl,sp
   call LD_HL_MHL
   ROM_CALL(D_ZT_STR)
#endasm
}


/* =======================================================================
   setxy(char x,y)
   set x/y
   ======================================================================= */
setxy(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)
   ld (CURSOR_POS),bc
#endasm
}



/* =======================================================================
   putc_m(char c)
   print char in menu text
   ======================================================================= */
putc_m(c) char c; {
#asm
   ld hl,2
   add hl,sp
   ld a,(hl)
   ROM_CALL(M_CHARPUT)
#endasm
}


/* =======================================================================
   puts_m(char* c)
   print string in menu text
   ======================================================================= */
puts_m(str) char* str; {
#asm
   ld hl,2
   add hl,sp
   call LD_HL_MHL
   ROM_CALL(D_ZM_STR)
#endasm
}


/* =======================================================================
   setxy(char x,y)
   set menu text x/y
   ======================================================================= */
setxy_m(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld b,(hl)
   inc hl
   inc hl
   ld c,(hl)
   ld (CURSOR_X),bc         
#endasm
}



#endif /* CRT_H */
