/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   key.h                          03/nov/98             lord_nexus@usa.net
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#ifndef KEY_H
#define KEY_H

/* --- contants ---------------------------------------------------------- */

/* getkey() contants */

#define K_NONE     0x00  /* NO KEY                   */
#define K_DOWN     0x01  /* DOWN                     */
#define K_LEFT     0x02  /* LEFT                     */
#define K_RIGHT    0x03  /* RIGHT                    */
#define K_UP       0x04  /* UP                       */

// uknown          [0x05-0x08]

#define K_ENTER    0x09  /* ENTER          ENTRY     */
#define K_PLUS     0x0A  /* +              MEM     " */
#define K_MINUS    0x0B  /* -              ]       W */
#define K_TIMES    0x0C  /* *              [       R */
#define K_STAR     0x0C  /*ZSLIB.H*/
#define K_DIV      0x0D  /* /                      M */
#define K_SLASH    0x0D  /*ZSLIB.H*/
#define K_POWER    0x0E  /* ^              pi      H */
#define K_RAISE    0x0E  /*ZSLIB.H*/
#define K_CLEAR    0x0F  /* CLEAR                    */

// uknown          0x10

#define K_NEG      0x11  /* (-)            ANS     ? */
#define K_SIGN     0x11  /*ZSLIB.H*/
#define K_3        0x12  /* 3              L3      theta  */
#define K_6        0x13  /* 6              L6      V */
#define K_9        0x14  /* 9              n       Q */
#define K_RPARAN   0x15  /* )              }       L */
#define K_RIGHTPAR 0x15  /*ZSLIB.H*/
#define K_TAN      0x16  /* TAN            TAN-1   G */
#define K_VARS     0x17  /* VARS           Y-VARS    */

// uknown          0x18

#define K_PERIODE  0x19  /* .              :         */
#define K_DOT      0x19  /*ZSLIB.H*/
#define K_2        0x1A  /* 2              L2      Z */
#define K_5        0x1B  /* 5              L5      U */
#define K_8        0x1C  /* 8              Vn-1    P */
#define K_LPARAN   0x1D  /* (              {       K */
#define K_LEFTPAR  0x1D  /*ZSLIB.H*/
#define K_COS      0x1E  /* COS            COS-1   F */
#define K_PRGM     0x1F  /* PRGM           DRAW    C */
#define K_STAT     0x20  /* STAT           LIST      */

#define K_0        0x21  /* 0                      space  */
#define K_1        0x22  /* 1              L1      Y */
#define K_4        0x23  /* 4              L4      T */
#define K_7        0x24  /* 7              Un-1    O */
#define K_COMMA    0x25  /* ,              EE      J */
#define K_SIN      0x26  /* SIN            SIN-1   E */
#define K_MATRIX   0x27  /* MATRIX         ANGLE   B */
#define K_XTO      0x28  /* X,T,theta      LINK      */
#define K_XVAR     0x28  /*ZSLIB.H*/

#define K_ON       0x29  /* ON             OFF       */
#define K_STO      0x2A  /* STO>           RCL     X */
#define K_LN       0x2B  /* LN             e^x     S */
#define K_LOG      0x2C  /* LOG            10^x    N */
#define K_SQR      0x2D  /* x^2            sqrt    I */
#define K_SQUARE   0x2D  /*ZSLIB.H*/
#define K_INVERSE  0x2E  /* x^-1           ABS     D */
#define K_MATH     0x2F  /* MATH           TEST    A */
#define K_ALPHA    0x30  /* ALPHA          A-LOCK    */

#define K_GRAPH    0x31  /* GRAPH          TABLE     */
#define K_F5       0x31  /*ZSLIB.H*/
#define K_TRACE    0x32  /* TRACE          CALC      */
#define K_F4       0x32  /*ZSLIB.H*/
#define K_ZOOM     0x33  /* ZOOM                     */
#define K_F3       0x33  /*ZSLIB.H*/
#define K_WINDOW   0x34  /* WINDOW         TblSet    */
#define K_F2       0x34  /*ZSLIB.H*/
#define K_YEDIT    0x35  /* Y=             STAT PLOT */
#define K_F1       0x35  /*ZSLIB.H*/

#define K_2ND      0x36  /* 2ND                      */
#define K_SECOND   0x36  /*ZSLIB.H*/
#define K_MODE     0x37  /* MODE           QUIT      */
#define K_EXIT     0x37  /*ZSLIB.H*/
#define K_DEL      0x38  /* DEL            INS       */

/* key_handler constants */

#define H_RIGHT       1  /* RIGHT     RIGHT     */
#define H_LEFT        2  /* LEFT      LEFT      */
#define H_UP          3  /* UP        UP        */
#define H_DOWN        4  /* DOWN      DOWN      */
#define H_ENTER       5  /* ENTER     ENTER     */
#define H_CLEAR       6  /* CLEAR     CLEAR     */
#define H_DEL         7  /* DEL       DEL       */
#define H_INS         8  /* DEL       INS       */
#define H_RCL         9  /* STO>      RCL       */
#define H_ENTRY      10  /* ENTER     ENTRY     */
#define H_BOL        11  /* LEFT      BOL       */
#define H_EOL        12  /* RIGTH     EOL       */
#define H_PRGM       45  /* PRGM      PRGM      */
#define H_ZOOM       46  /* ZOOM      ZOOM      */
#define H_DRAW       47  /* PRGM      DRAW      */
#define H_PLOT       48  /* Y=        STAT PLOT */
#define H_MATH       49  /* MATH      MATH      */
#define H_TEST       50  /* MATH      TEST      */
#define H_VARS       52  /* VARS      VARS      */
#define H_MEM        53  /* +         MEM       */
#define H_MATRIX     54  /* MATRIX    MATRIX    */
#define H_STAT       55  /* STAT      STAT      */
#define H_Y_VARS     56  /* VARS      Y-VARS    */
#define H_ANGLE      57  /* MATRIX    ANGLE     */
#define H_LIST       58  /* STAT      LIST      */
#define H_CALC       59  /* TRACE     CALC      */
#define H_QUIT       64  /* MODE      QUIT      */
#define H_LINK       65  /* x,T,theta LINK      */
#define H_GRAPH      69  /* GRAPH     GRAPH     */
#define H_MODE       70  /* MODE      MODE      */
#define H_WINDOW     73  /* WINDOW    WINDOW    */
#define H_YEDIT      74  /* Y=        Y=        */
#define H_TABLE      75  /* GRAPH     TABLE     */
#define H_TBLSET     76  /* WINDOW    TblSet    */
#define H_TRACE      93  /* TRACE     TRACE     */
#define H_PLUS      129  /* +         +         */
#define H_MINUS     130  /* -         -         */
#define H_TIMES     131  /* *         *         */
#define H_DIV       132  /* /         /         */
#define H_POWER     133  /* ^         ^         */
#define H_LPARAN    134  /* (         (         */
#define H_RPARAN    135  /* )         )         */
#define H_LBRACK    136  /* *         [         */
#define H_RBRACK    137  /* -         ]         */
#define H_STO       139  /* STO>      STO>      */
#define H_COMMA     140  /* ,         ,         */
#define H_NEG       141  /* (-)       (-)       */
#define H_PERIODE   142  /* .         .         */
#define H_0         143  /* 0         0         */
#define H_1         144  /* 1         1         */
#define H_2         145  /* 2         2         */
#define H_3         146  /* 3         3         */
#define H_4         147  /* 4         4         */
#define H_5         148  /* 5         5         */
#define H_6         149  /* 6         6         */
#define H_7         150  /* 7         7         */
#define H_8         151  /* 8         8         */
#define H_9         152  /* 9         9         */
#define H_EE        153  /* ,         EE        */
#define H_SEMI      154  /* 0          /*       */
#define H_A         155  /* MATH      A         */
#define H_B         156  /* MATRIX    B         */
#define H_C         157  /* PRGM      C         */
#define H_D         158  /* X^-1      D         */
#define H_E         159  /* SIN       E         */
#define H_F         160  /* COS       F         */
#define H_G         161  /* TAN       G         */
#define H_H         162  /* ^         H         */
#define H_I         163  /* X^2       I         */
#define H_J         164  /* ,         J         */
#define H_K         165  /* (         K         */
#define H_L         166  /* )         L         */
#define H_M         167  /* /         M         */
#define H_N         168  /* LOG       N         */
#define H_O         169  /* 7         O         */
#define H_P         170  /* 8         P         */
#define H_Q         171  /* 9         Q         */
#define H_R         172  /* *         R         */
#define H_S         173  /* LN        S         */
#define H_T         174  /* 4         T         */
#define H_U         175  /* 5         U         */
#define H_V         176  /* 6         V         */
#define H_W         177  /* -         W         */
#define H_X         178  /* STO>      X         */
#define H_Y         179  /* 1         Y         */
#define H_Z         180  /* 2         Z         */
#define H_XTO       181  /* x,T,theta x,T,theta */
#define H_PI        182  /* ^         Pi        */
#define H_INVERSE   183  /* X^-1      X^-1      */
#define H_SIN       184  /* SIN       SIN       */
#define H_ASIN      185  /* SIN       SIN^-1    */
#define H_COS       186  /* COS       COS       */
#define H_ACOS      187  /* COS       COS^-1    */
#define H_TAN       188  /* TAN       TAN       */
#define H_ATAN      189  /* TAN       TAN^-1    */
#define H_SQR       190  /* X^2       X^2       */
#define H_SQRT      191  /* X^2       SQRT      */
#define H_LN        192  /* LN        LN        */
#define H_EX        193  /* LN        e^X       */
#define H_LOG       194  /* LOG       LOG       */
#define H_TENP      195  /* LOG       10^X      */
#define H_ANS       198  /* (-)       ANS       */
#define H_COLON     199  /* .         :         */
#define H_QUEST     203  /* (-)       ?         */
#define H_QUOTE     204  /* +         "         */
#define H_THETA     205  /* 3         THETA     */
#define H_LBRACE    237  /* (         {         */
#define H_RBRACE    238  /* )         }         */
#define H_ABS       244  /* X^-1      ABS       */
#define H_L1        245  /* 1         L1        */
#define H_L2        246  /* 2         L2        */
#define H_L3        247  /* 3         L3        */
#define H_L4        248  /* 4         L4        */
#define H_L5        249  /* 5         L5        */
#define H_L6        250  /* 6         L6        */
#define H_n_        251  /* 9         n         */
#define H_Vn1       252  /* 8         Vn-1      */
#define H_Un1       253  /* 7         Un-1      */

/* ascii constants */

#define A_RIGHT    0x05      /* RIGHT */
#define A_UP       0x06      /* UP */
#define A_DOWN     0x07      /* DOWN */
#define A_LEFT     0x08      /* LEFT */
#define A_BS       0x08      /* LEFT */

#define A_TAB      0x09
#define A_LF       0x0a
#define A_CR       0x0d      /* ENTER */
#define A_EOF      0x1a
#define A_ESC      0x1b      /* MODE */

#define A_DEL      0x7f      /* DEL */

/* --- variables --------------------------------------------------------- */


/* --- defines ----------------------------------------------------------- */


/* --- functions --------------------------------------------------------- */


/* =======================================================================
   char getkey()
   return current keypress (K_xx)
   ======================================================================= */
kbhit() {
#asm
   call GET_KEY
   ld l,a
   xor a
   ld h,a
#endasm
}

key_read() {
#asm
   ld a,$ff
   call KEY_READ
   ld l,a
   xor a
   ld h,a
#endasm
}


/* =======================================================================
   char getkey()
   wait for keypress then return key (K_xx)
   ======================================================================= */
getkey() {
#asm
_getkey_loop:
   halt                 ; to reduce power consumption
   call GET_KEY
   cp 0
   jr z,_getkey_loop
   ld l,a
   xor a
   ld h,a
#endasm
}


/* =======================================================================
   char getkey_h()
   wait for keypress from handler then return key (H_xx)
   ======================================================================= */
getkey_h() {
#asm
_getkey_h_loop:
   halt                 ; to reduce power consumption
   call KEY_HAND
   cp 0
   jr z,_getkey_h_loop
   ld l,a
   xor a
   ld h,a
#endasm
}


#endif /* KEY_H */
