#ifndef BEEP_C
#define BEEP_C

/* Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/~jdewey

   Synopsis:
      beep(int tone, int length)

   Description:
      Generates a tone of the given freq and duration

   Example: 
      beep(560, 200)

   Notes:
      o I have not tested this function, as I have no speaker on my TI

; Date:     Sun, 24 Mar 1996 10:00:35
; From:     Eric Linenberg  [ELinenberg@gnn.com]
; Subject:  LZ: SOUND routine

; This message comes from the List-ZShell mailing list:

; Do you want sound in your ZShell games
; THEN*USE*THIS*ROUTINE*

; reasons why you should use this:
; 1.sound is cool
; 2.takes up almost NO MEMORY
; 3.games are more fun
; 4.Breakout will KICK ASS

; reasons why you shouldn't use this:
; 1.if you want a song get my next routine
; 2.NONE

;ld de with length 1-65535
;ld hl with tone   1-65535
;then CALL_(beep)
*/

beep(tone, length) int tone, length; {
#asm
	ld	hl,2
	add	hl,sp
	call	LD_HL_MHL	; hl now contains length
	ld	e,l
	ld	d,h		; de now contains length

	ld	hl,4
	add	hl,sp
	call	LD_HL_MHL	; hl now contains tone

        di        
_beepst:
;set_low
   	ld  	b,%11111100         
        ld      c,P_LINK      
   	out  	(c),b          
  	push 	hl
_bpd1:
   	dec  	hl
   	ld   	a,l
   	or	h
   	jr   	nz,_bpd1
   	pop	hl
;set_high:
   	ld  	b,%11000000         
        ld      c,P_LINK
   	out 	(c),b          
        push 	hl
_bpd2:
   	dec  	hl
    	ld   	a,l
    	or   	h
    	jr   	nz,_bpd2
    	pop	hl
	dec 	de
   	ld	a,d
   	cp	0
   	jr      nz,_beepst
   	ei
#endasm
}

#endif
