/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   graph.h                        07/nov/98             lord_nexus@usa.net
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   direct graphics library

   graphpage
   putpixel(char x,y)
   delpixel(char x,y)
   chgpixel(char x,y)
   char getpixel(char x,y)
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#ifndef GRAPH_H
#define GRAPH_H

/* --- defines ----------------------------------------------------------- */

/* set rom page to 4 req. for FIND_PIXEL */
#define graphpage asm("\tLD A,$8C\n\tOUT (2),A\n")


/* --- functions --------------------------------------------------------- */

/* =======================================================================
   putpixel(char x,y)                                       dines justesen
   ======================================================================= */
putpixel(x,y) char x,y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)
_putpix:
        CALL FIND_PIXEL
        LD B,A
        LD A,($8011)        ; Goto line
        CALL DISP_DELAY
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        CALL DISP_DELAY
        OUT ($10),A
        CALL DISP_DELAY
        IN A,($11)          ; Get byte
        CALL DISP_DELAY
	IN A,($11)
        OR B                ; Set pixel
        LD B,A
        LD A,($8011)        ; Goto line
        CALL DISP_DELAY
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        CALL DISP_DELAY
        OUT ($10),A
        LD A,B
        CALL DISP_DELAY
        OUT ($11),A
#endasm
}


/* =======================================================================
   delpixel(char x,y)                                       dines justesen
   ======================================================================= */
delpixel(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)
_delpix:
        CALL FIND_PIXEL
        XOR $0FF            ; Invert mask
        LD B,A
        LD A,($8011)        ; Goto line
        CALL DISP_DELAY
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        CALL DISP_DELAY
        OUT ($10),A
        CALL DISP_DELAY
	IN A,($11)          ; Get byte
        CALL DISP_DELAY
	IN A,($11)
        AND B
        LD B,A
        LD A,($8011)        ; Goto line
        CALL DISP_DELAY
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        CALL DISP_DELAY
        OUT ($10),A
        LD A,B
        CALL DISP_DELAY
        OUT ($11),A
#endasm
}


/* =======================================================================
   chgpixel(char x,y)                                       dines justesen
   ======================================================================= */
chgpixel(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)
_chgpix:
        CALL FIND_PIXEL
        LD B,A
        LD A,($8011)
        CALL DISP_DELAY
        OUT ($10),A
        LD A,($800F)
        CALL DISP_DELAY
        OUT ($10),A
        CALL DISP_DELAY
        IN A,($11)          ; Get byte
        CALL DISP_DELAY
	IN A,($11)
        XOR B               ; Invert pixel
        LD B,A
        LD A,($8011)
        CALL DISP_DELAY
        OUT ($10),A
        LD A,($800F)
        CALL DISP_DELAY
        OUT ($10),A
        LD A,B
        CALL DISP_DELAY
        OUT ($11),A
#endasm
}


/* =======================================================================
   char getpixel(char x,y)                                  dines justesen
   ======================================================================= */
getpixel(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)

_getpix:
        CALL FIND_PIXEL ; HL=byte offset in video buffer, A=2^(bit to change)
        LD B,A
        LD A,($8011)        ; Goto line
        CALL DISP_DELAY
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        CALL DISP_DELAY
        OUT ($10),A
        CALL DISP_DELAY          ; Get byte
        IN A,($11)
        CALL DISP_DELAY
	IN A,($11)
        AND B               ; Mask, so only one pixel left
#endasm
}

#endif /* GRAPH_H */
