/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   libgm\graph.h                  07/nov/98             lord_nexus@usa.net
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   graph_mem -- memory mapped graphics library

   graphpage
   disp_graph
   bufclr()
   bufcpy()
   putpixelm(char x,y)
   delpixelm(char x,y)
   chgpixelm(char x,y)   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#ifndef GRAPH_H
#define GRAPH_H

#define  _GRAPH_MEM    $88B8
#define  _APD_BUF      $8228

/* --- defines ----------------------------------------------------------- */

/* set rom page to 4 req. for FIND_PIXEL */
#define graphpage asm("\tLD A,$8C\n\tOUT (2),A\n")

/* display contents of graph mem, __USE CR_GRBCOPY__  */
#define disp_graph asm("\tROM_CALL(DISP_GRAPH)\n")

/* display contents of graph mem */
#define cr_grbcopy asm("\tcall CR_GRBCopy\n")


/* --- functions --------------------------------------------------------- */

/* =======================================================================
   bufclr()                                                              ?
   graph mem clear           
   ======================================================================= */
bufclr() {
#asm
                ld              hl,GRAPH_MEM
                ld              de,GRAPH_MEM+1
                ld              bc,$2ff
                ld              (hl),0
                ldir
#endasm
}

/* =======================================================================
   apdclr()                                                              ?
   APD_BUF clear           
   ======================================================================= */
apdclr() {
#asm
                ld              hl,APD_BUF
                ld              de,APD_BUF+1
                ld              bc,$2ff
                ld              (hl),0
                ldir
#endasm
}


/* =======================================================================
   bufcpy()                                             lord_nexus@usa.net
   copy apd -> graphmem      
   ======================================================================= */
apd2buf() {
#asm
                ld              hl,APD_BUF
                ld              de,GRAPH_MEM
                ld              bc,$300
                ldir
#endasm
}

/* =======================================================================
   pixdest_apd()                                        lord_nexus@usa.net
   set pix functions destination to APD_BUF
   ======================================================================= */
pixdest_apd() {
#asm
                ld              hl,APD_BUF
                ld              (_putpix_buf+1),hl
                ld              (_delpix_buf+1),hl
                ld              (_chgpix_buf+1),hl
#endasm
}

/* =======================================================================
   pixdest_grb()                                        lord_nexus@usa.net
   set pix functions destination to GRAPH_MEM
   ======================================================================= */
pixdest_grb() {
#asm
                ld              hl,GRAPH_MEM
                ld              (_putpix_buf+1),hl
                ld              (_delpix_buf+1),hl
                ld              (_chgpix_buf+1),hl
#endasm
}




/* =======================================================================
   putpixelm(char x,y)                                       jimmy mardell
   GRAPH_MEM put pixel 
   ======================================================================= */
putpixelm(x,y) char x,y; {
#asm
                ld              hl,2
                add             hl,sp
                ld              c,(hl)
                inc             hl
                inc             hl
                ld              b,(hl)
_putpix:
                CALL            FIND_PIXEL          
_putpix_buf     ld              de,GRAPH_MEM
                add             hl,de
                or              (hl)
                ld              (hl),a
#endasm
}


/* =======================================================================
   delpixelm(char x,y)
   GRAPH_MEM del pixel 
   ======================================================================= */
delpixelm(x,y) char x,y; {
#asm
                ld              hl,2
                add             hl,sp
                ld              c,(hl)
                inc             hl
                inc             hl
                ld              b,(hl)
_delpix:
                CALL            FIND_PIXEL          
_delpix_buf     ld              de,GRAPH_MEM
                add             hl,de
                and             (hl)
                ld              (hl),a
#endasm
}


/* =======================================================================
   chgpixelm(char x,y)
   GRAPH_MEM chg pixel 
   ======================================================================= */
chgpixelm(x,y) char x,y; {
#asm
                ld              hl,2
                add             hl,sp
                ld              c,(hl)
                inc             hl
                inc             hl
                ld              b,(hl)
_chgpix:
                CALL            FIND_PIXEL 
_chgpix_buf     ld              de,GRAPH_MEM
                add             hl,de
                xor             (hl)
                ld              (hl),a
#endasm
}

#endif /* GRAPH_H */
