/*	File main.c: 2.7 (84/11/28,10:14:56) */
/*% cc -O -c %
 *
 */

#include <stdio.h>
#include "defs.h"
#include "data.h"

main (argc, argv)
int	argc, *argv;
{
	char	*p,*bp,*desc,*libs;
	int smacptr;
	macptr = 0;
	ctext = 0;
	argc--; argv++;
	errs = 0;
	aflag = 1;
#ifdef	FRAME_IX
	frameix = 0;
#endif
	while (p = *argv++)
		if (*p == '-') while (*++p)
			switch(*p) {
				case 't': case 'T':
					ctext = 1;
					break;
				case 's': case 'S':
					sflag = 1;
					break;
				case 'c': case 'C':
					cflag = 1;
					break;
				case 'a': case 'A':
					aflag = 0;
					break;
				case 'd': case 'D':
					bp = ++p;
					if (!*p) usage();
					while (*p && *p != '=') p++;
					if (*p == '=') *p = '\t';
					while (*p) p++;
					p--;
					defmac(bp);
					break;
#ifdef	FRAME_IX
				case 'x': case 'X':
					frameix = 1;
					break;
#endif
				default:
					usage();
			}
			else break;

	smacptr = macptr;
   inccase = 0;
   incmult = 0;
   incdiv  = 0;
	if (!p)
		usage();
           fputs("Small C (v4.0) ash lord_nexus@usa.net\n",stderr);
		errfile = 0;
		if (xtypeof(p) == 'c' || xtypeof(p) == 'i') {
			glbptr = STARTGLB;
			locptr = STARTLOC;
			wsptr = ws;
			inclsp =
			iflevel =
			skiplevel =
			swstp =
			litptr =
			stkp =
			errcnt =
			ncmp =
			lastst =
			quote[1] =
         r_label =
			0;
			macptr = smacptr;
			input2 = NULL;
			quote[0] = '"';
			cmode = 1;
			glbflag = 1;
			nxtlab = 0;
			litlab = getlabel ();
			defmac("end\tmemory");
			rglbptr = glbptr;
			defmac("short\tint");
			initmac();
			/*
			 *	compiler body
			 */
			if (!openin (p))
				return (1);
			if (!openout ())
				return (1);
			desc = getdesc();
         libs = getlibs();
         header (desc ? desc : p, libs ? libs : "");
			gtext ();
			parse ();
			fclose (input);
         if (inccase) outstr ("#define inc_case\n");
         if (incmult) outstr ("#define inc_mult\n");
         if (incdiv)  outstr ("#define inc_div\n");
         if (inccase || incmult || incdiv)
            outstr ("#include \"ash_crt.asm\"\n");
			gdata ();
			dumplits ();
			gbss ();
			dumpglbs ();
			errorsummary ();
			trailer ();
			fclose (output);
			errs = errs || errfile;
		} else {
			fputs("Don't understand file ", stderr);
			fputs(p, stderr);
			fputs("\n", stderr);
			errs = 1;
		}
		p = *argv++;
	exit(errs != 0);
}

FEvers()
{
	outstr("\tFront End (2.7,84/11/28)");
}

usage()
{
	fputs("usage: zcc [-t] [-dSYM[=VALUE]] file.c [\"description\"]\n", stderr);
   fputs("\n       -t  include source in output file\n", stderr);
	exit(1);
}

/*
 *	process all input text
 *
 *	at this level, only static declarations, defines, includes,
 *	and function definitions are legal.
 *
 */

char desc[80];
getdesc () {
   int i = 0;
   if (match ("#name")) {
      blanks();
      if (ch() != '"') {
         error ("Invalid program description");
         return NULL;
      }
      gch();
      while (ch() != '"' && ch()) {
         desc[i++] = gch();
         if (i > 79) {
            error("Program description too long");
            return NULL;
         }
      }
      gch();
      desc[i] = 0;
      return desc;
   }
   return NULL;
}

char libs[80];
getlibs () {
   int i = 0;
   if (match ("#libs")) {
      blanks();
      while (ch()) {
         if (numeric(ch()) || ch()==',')
            libs[i++] = ch();
         gch();
      }
      libs[i++] = ',';
      libs[i] = 0;
      gch();
      return libs;
   }
   return NULL;
}

parse ()
{
	while (!feof (input)) {
		if (amatch ("extern", 6))
			dodcls(EXTERN);
		else if (amatch ("static",6))
			dodcls(STATIC);
		else if (dodcls(PUBLIC)) ;
		else if (match ("#asm"))
			doasm ();
		else if (match ("#include"))
			doinclude ();
		else if (match ("#define"))
			dodefine();
		else if (match ("#undef"))
			doundef();
		else if (match ("#line") | match("#"))
			kill();
      else
			newfunc ();
		blanks ();
	}
}

/*
 *		parse top level declarations
 */

dodcls(stclass)
int stclass; {
	blanks();
	if (amatch("char", 4))
		declglb(CCHAR, stclass);
	else if (amatch("int", 3))
		declglb(CINT, stclass);
	else if (stclass == PUBLIC)
		return(0);
	else
		declglb(CINT, stclass);
	ns ();
	return(1);
}


/*
 *	dump the literal pool
 */
dumplits ()
{
	int	j, k;

	if (litptr == 0)
		return;
	printlabel (litlab);
	col ();
	k = 0;
	while (k < litptr) {
		defbyte ();
		j = 8;
		while (j--) {
			outdec (litq[k++] & 127);
			if ((j == 0) | (k >= litptr)) {
				nl ();
				break;
			}
			outbyte (',');
		}
	}
}

/*
 *	dump all static variables
 */
dumpglbs ()
{
	int	j;
   int   text_ptr;

   text_ptr = 0x808f;		// ti 82 text mem
	if (!glbflag)
		return;
	cptr = rglbptr;
	while (cptr < glbptr) {
		if (cptr[IDENT] != FUNCTION) {
			ppubext(cptr);
			if (cptr[STORAGE] == STATIC) {
		prefix ();
	    outstr (cptr);
	    col ();
	    /*defstorage ();*/
				j = glint(cptr);
				if ((cptr[TYPE] == CINT) || (cptr[IDENT] == POINTER))
					j = j * intsize();
	    /*onum (j);*/
            nl ();
            out_static(j);
         } else if (cptr[STORAGE] == EXTERNP) {
            prefix ();
            outstr (cptr);
            outstr ("\t= $");
            outhex (cptr[ADDRESS+1]);
            outhex (cptr[ADDRESS]);
            nl ();
         } else if (cptr[STORAGE] != EXTERN) {
	      prefix ();
	      outstr (cptr);
	      outstr ("\t= ");
	      outdec (text_ptr);
	      nl ();
				j = glint(cptr);
				if ((cptr[TYPE] == CINT) || (cptr[IDENT] == POINTER))
					j = j * intsize();
				text_ptr+=j;
	    if (text_ptr>33159) error("Public variables exceed text memory");
	 }
		} else {
			fpubext(cptr);
		}
		cptr = cptr + SYMSIZ;
	}
}

out_static(size) int size; {
	int k;

   if (size == 1) {
   	outstr(".db\t0\n");
   	return;
   }
   k=7; size-=2;
   outstr(".dw\t0");
   while ((size)>1) {
		outstr(",0");
      size-=2;
      if (--k == 0) {
      	if (size>1) {
         	outstr("\n.dw\t0");
            size-=2;
         } else if (size==1) {
         	outstr("\n.db\t0");
            size=0;
      	}
         k=8;
      }
   }
   nl();
   if (size) outstr(".db 0\n");
}

/*
 *	report errors
 */
errorsummary ()
{
	if (ncmp)
		error ("missing closing bracket");
	nl ();
	comment ();
	outdec (errcnt);
	if (errcnt) errfile = YES;
	outstr (" error(s) in compilation");
	nl ();
	comment();
	ot("literal pool:");
	outdec(litptr);
	nl();
	comment();
	ot("global pool:");
	outdec(glbptr-rglbptr);
	nl();
	comment();
	ot("Macro pool:");
	outdec(macptr);
	nl();
	if (errcnt)
		pl("Error(s)\n");
}

xtypeof(s)
char	*s; {
	s += strlen(s) - 2;
	if (*s == '.')
		return(*(s+1));
	return(' ');
}
