#name "DewSoft Stones v0.5"
#libs 6
/*
   This is a nearly complete game I've been writing. I feel that it makes a
   good example of a complex small c application. It also presents a very
   clean and attractive user interface that I highly encourage everyone to
   see.

   This file is copyright 1997 by Jeremy Dewey.
*/

// #include "usglib.h"
#include "system.h"
#include "key.h"
#include "crt.h"
#include "libg\graph.h"
#include "lib\tabline.c"
#include "lib\sprite.c"
#include "lib\sprite_x.c"
#include "lib\rand.c"
// #include "usglib\displib.h"

#define true 1
#define false 0

#define P_BLOCK 25
#define P_HUMAN -10
#define P_CPU 10

/* Sprites - actual data at end of file */
extern char icon_h[], icon_hi[], icon_c[], icon_ci[], icon_sq[];
extern char wait_L1[], wait_0[], icon_0[], icon_b[], square[];
/* Various pointers */
char *brd, *p_wait, i_wait;
/* Human's current cursor position */
int cx, cy;
/* Current scores */
char numci, numc, numhi, numh, nummt;
char onumci, onumc, onumhi, onumh;
extern char* _frstmem(0x8b27);

main() {
   char i;
   i_wait = 0;
   cx = 8;
   cy = 5;

   brd = _frstmem;
   clrscr;
   graphpage;
//   disp_setmode(DISP_MENU);
   tabline("Stones v0.5");
   /* Print my name */
   _menu_x = 70;
   puts_m("by Jeremy Dewey");

   /* Draw message window */
   vline(0,54,92);

   /* Populate message window */
   setxy_m(100,8);
   puts_m("Human");
   for (i=49;i<55;i++) hline(93,127,i);
   setxy_m(103,15);
   puts_m("0 ");
   sprite(icon_h,_menu_x, 43,5,5);
   setxy_m(103,21);
   puts_m("0 ");
   sprite(icon_hi,_menu_x, 37,5,5);
   setxy_m(103,27);
   puts_m("0 Total");

   setxy_m(95,36);
   puts_m("CPU stats");
   for (i=21;i<28;i++) hline(93,127,i);
   setxy_m(103,43);
   puts_m("0 ");
   sprite(icon_c,_menu_x, 15,5,5);
   setxy_m(103,49);
   puts_m("0 ");
   sprite(icon_ci,_menu_x, 9,5,5);
   setxy_m(103,55);
   puts_m("0 Total");

   init_brd();
   draw_brd();
   play();
   getkey();
}

play() {
   nummt=1;
   while (nummt) {
      human();
      draw_brd();
      if (nummt) {
         cpu();
         draw_brd();
      }
   }
}

waitcycl() {
   p_wait = wait_L1 + i_wait * 10;
   sprite(p_wait  ,48,57,8,5);
   sprite(p_wait+5,56,57,8,5);
   if (++i_wait >=4) i_wait=0;
}

waitoff() {
   sprite(wait_0, 48,57,8,5);
   sprite(wait_0, 56,57,8,5);
}

init_brd() {
   int x,y,b;

   for(y=0;y<11;y++) {
      /*waitcycl();*/
      for(x=0;x<16;x++) {
         b = bindex(x,y);
         if (!x || x==15 || !y || y==10 || rand16() < 5000) {
            brd[b] = P_BLOCK;
         }
         else brd[b] = 0; /*crap[x-1];*/
      }
   }
}

draw_brd() {
   int xx,yy,x,y,b;
   char* spr;

   yy = 1;
   onumci = numci;
   onumc = numc;
   onumhi = numhi;
   onumh = numh;

   numci = numc = numhi = numh = nummt = 0;
   for(y=1;y<10;y++) {
      waitcycl();
      xx = 1;
      for(x=1;x<15;x++) {
         b = bindex(x,y);
         if (brd[b]==P_BLOCK) spr = icon_b;
         else if (brd[b]==P_HUMAN) { spr = icon_h; numh++;}
         else if (brd[b]==P_CPU) { spr = icon_c; numc++;}
         else if (brd[b]>127) { spr = icon_hi; numhi++;}
         else if (!brd[b]) { spr = icon_0; nummt++;}
         else { spr = icon_ci; numci++;}
         sprite(spr,xx,yy,5,5);
         xx+=6;
      }
      yy+=6;
   }
   waitoff();
   draw_scr(15,onumh,numh);
   draw_scr(21,onumhi,numhi);
   draw_scr(27, onumh+onumhi,numh+numhi);

   draw_scr(43,onumc,numc);
   draw_scr(49,onumci,numci);
   draw_scr(55,onumc+onumci,numc+numci);
}

draw_scr(y,os,ns) char y,os,ns; {
   draw_sc2(y,os);
   draw_sc2(y,ns);
}

draw_sc2(y,scr) char y,scr; {
   setxy_m(95, y);
//   disp_dec_char(scr);
}

human() {
   int c,done,xx,yy;
   done = 0;

   do {
      xx = cx*6-6;
      yy = cy*6-6;
      sprite_x(square,xx,yy,7,7);
      c = getkey();
      sprite_x(square,xx,yy,7,7);
      if (c == K_UP) {
         if (cy < 9) cy++;
         else cy = 1;
      } else if (c == K_DOWN) {
         if (cy > 1) cy--;
         else cy = 9;
      } else if (c == K_LEFT) {
         if (cx > 1) cx--;
         else cx = 14;
      } else if (c == K_RIGHT) {
         if (cx < 14) cx++;
         else cx = 1;
      } else if (c == K_EXIT)
         exit;
      else if (c == K_SECOND) {
         if (islegal(cx,cy,P_HUMAN)) {
            done = 1;
            execute(cx,cy,P_HUMAN);
         }
      }
   } while (!done);
   draw_brd();
}

cpu() {
   int x,y;

   for (y=1;y<10;y++)
      for (x=1;x<15;x++)
         if (islegal(x,y,P_CPU)) {
            execute(x,y,P_CPU);
            return;
         }
}

islegal(x,y,p) int x,y,p; {
   char b;
   b = brd[bindex(x,y)];
   if (!b || (sign(b)==sign(p) && b!=p && b!=P_BLOCK))
      return true;
   return false;
}

sign(a) char a; {
   if (a>127) return -1;
   return 1;
}

bindex(x,y) int x,y; {
   return (y<<4)+x;
}

abs(a) char a; {
   if (a>127) return -a;
   return a;
}

execute(x,y,p) int x,y,p; {
   int a,b,xx,yy,bb;

   for(a=0;a<3;a++)
      for(b=0;b<3;b++) {
         xx = x + b - 1;
         yy = y + a - 1;
         bb = bindex(xx,yy);
         if (b==1 && a==1) brd[bb] = p;
         else if (abs(brd[bb]) < 10) brd[bb]+=sign(p);
      }
}

/* Sprite data */
#asm
;crap:
;.db -10,-6,-3,0,25,0,3,6,10,6,0,-10,5,0
icon_h:
.db %00100000
.db %01110000
.db %11111000
.db %01110000
.db %00100000
icon_hi:
.db %00100000
.db %01010000
.db %10001000
.db %01010000
.db %00100000
icon_c:
.db %01110000
.db %11111000
.db %11111000
.db %11111000
.db %01110000
icon_ci:
.db %01110000
.db %10001000
.db %10001000
.db %10001000
.db %01110000
icon_b:
.db %11111000
.db %10101000
.db %11011000
.db %10101000
.db %11111000
icon_0:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
square:
.db %11111110
.db %10000010
.db %10000010
.db %10000010
.db %10000010
.db %10000010
.db %11111110
wait_0:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
wait_L1:
.db %11111111
.db %10011001
.db %10110011
.db %11100110
.db %11111111
wait_1R:
.db %11111111
.db %10011001
.db %00110011
.db %01100111
.db %11111111
wait_2L:
.db %11111111
.db %10110011
.db %11100110
.db %11001100
.db %11111111
wait_2R:
.db %11111111
.db %00110011
.db %01100111
.db %11001101
.db %11111111
wait_3L:
.db %11111111
.db %11100110
.db %11001100
.db %10011001
.db %11111111
wait_3R:
.db %11111111
.db %01100111
.db %11001101
.db %10011001
.db %11111111
wait_4L:
.db %11111111
.db %11001100
.db %10011001
.db %10110011
.db %11111111
wait_4R:
.db %11111111
.db %11001101
.db %10011001
.db %00110011
.db %11111111
#endasm

/* Hide String (defined here because of special character
   You can use the char.c (a sample program) to find the numbers of
   other special characters */
#asm
point:
.db 5,5,5,0
#endasm

