/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   wolf3d82.c v0.1                                      lord_nexus@usa.net
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   this is a very rough port of the wolf3d raycasting technique.

   limitations
      - probably needs optimization (acc lacks this)
      - turn screws up (bug)

   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

#name "wolf3d82.c v0.1"
#include "system.h"
#include "libgm\graph.h"
#include "key.h"

extern int px;
extern int py;
extern int ph;
extern char grid[];
extern int sintable[];
extern int costable[];
#asm
px:             .dw              300

py:             .dw              300

ph:             .dw              180

grid:           .db              1, 1, 1, 1, 1, 1, 1, 1
		.db              1, 0, 0, 0, 0, 0, 0, 1
		.db              1, 0, 0, 0, 0, 0, 0, 1
		.db              1, 0, 0, 0, 0, 0, 0, 1
		.db              1, 0, 0, 0, 0, 0, 0, 1
		.db              1, 0, 0, 0, 0, 0, 0, 1
		.db              1, 0, 0, 0, 0, 0, 0, 1
		.db              1, 1, 1, 1, 1, 1, 1, 1

#include        "trig10.asm"
#endasm


int wa,wb,wl;
int stepx,stepy;
int rayx,rayy;
int g,j,p;
int newpx,newpy,newph;

update() {
#asm
                ld              hl,$88b8        ;
                ld              de,$88b9        ;
                ld              bc,$2ff         ;
                ld              (hl),0          ;
                ldir                            ; bufclr()
#endasm
   wb = 1;
   for (wa = ph+32 ; wa>ph-31 ; wa-=3) {
      newph = (wa<0 ? wa+360 : (wa>359 ? wa-360 : wa ));

      stepx = sintable[newph];
      stepy = costable[newph];

      rayx = px;
      rayy = py;
      wl = 0;
      do {
         rayx -= stepx;
         rayy -= stepy;
         wl++;
      }  while (grid[(((rayy-1)/100)<<3) + ((rayx-1)/100)]==0);

      g = 320 / wl;
      j = 32 - g;
      p = j+(g<<1);

      putpixelm(wb, j<0  ? 0  : j);
      putpixelm(wb, p>64 ? 64 : p);
      wb+=4;
   }
#asm
_CR_GRBCopy     LD              A,$80

                OUT             (P_LCD_CON),A           ; lcd y = 0
                LD              HL,GRAPH_MEM
                
                LD              C,$20
                LD              A,C

_CR_GRBCopy_x   INC             DE
                LD              DE,$000d

                CALL            DISP_DELAY
                OUT             (P_LCD_CON),A           ; lcd x = 0
                DEC             DE
                LD              B,$3f

_CR_GRBCopy_y   LD              A,(HL)          ; grab byte from GRAPH_MEM
                ADD             HL,DE

                CALL            DISP_DELAY
                OUT             (P_LCD_DATA),A    ; lcd disp byte
                DJNZ            _CR_GRBCopy_y
                LD              DE,$fd0d
                LD              A,(HL)
                ADD             HL,DE

                CALL            DISP_DELAY
                OUT             (P_LCD_DATA),A    ; lcd disp byte
                INC             C
                LD              A,C
                CP              $2d
                JR              NZ,_CR_GRBCopy_x
#endasm
}


main() {
   int_fastest;
   graphpage;

   while (1) {
      update();
      switch (getkey()) {
         case K_UP    : newph = (ph<0 ? ph+360 : (ph>359 ? ph-360 : ph ));
                        newpx = px - (sintable[newph] << 2);
                        newpy = py - (costable[newph] << 2);
                        if (grid[(((newpy-1)/100)<<3) + ((newpx-1)/100)] == 0) {
                           px = newpx;
                           py = newpy;
                        }
                        continue;
         case K_LEFT  : ph = (ph + 5) % 360;
                        continue;
         case K_RIGHT : ph = (ph - 5) % 360;
                        continue;
         case K_DOWN  : newph = (ph<0 ? ph+360 : (ph>359 ? ph-360 : ph ));
                        newpx = px + (sintable[newph] << 2);
                        newpy = py + (costable[newph] << 2);
                        if (grid[(((newpy-1)/100)<< 3) + ((newpx-1)/100)] == 0) {
                           px = newpx;
                           py = newpy;
                        }
                        continue;
         case K_MODE  : exit;
      }
   }
}
